#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>



int pini[16] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7, 
			    PC0, PC1, PC2, PC3, PC4, PC5, PC6, PC7};


void succesiv(){
	DDRA = DDRB = DDRC = 0;
	PORTA =	PORTB = PORTC = 0;

	DDRC |= (1 << PC0)|(1 << PC1)|(1 << PC2)|(1 << PC3)|(1 << PC4)|(1 << PC5)|(1 << PC6)|(1 << PC7);
	DDRA |= (1 << PA0)|(1 << PA1)|(1 << PA2)|(1 << PA3)|(1 << PA4)|(1 << PA5)|(1 << PA6)|(1 << PA7);
	DDRB |= (1 << PB0)|(1 << PB1)|(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7);


	DDRD = 0; PORTD = 0;
	DDRD |= (1 << PD7) | (1 << PD6) | (1 << PD5) | (1 << PD4);
	PORTD |= (1 << PD7) | (1 << PD6) | (1 << PD5) | (1 << PD4);

	while(1){
			PORTC |= (1 << PC0) | (1 << PC1) |(1 << PC2)|(1 << PC3)|(1 << PC4)|(1 << PC5)|(1 << PC6)|(1 << PC7);
			PORTA |= (1 << PA0) | (1 << PA1) |(1 << PA2)|(1 << PA3)|(1 << PA4)|(1 << PA5)|(1 << PA6)|(1 << PA7);
			PORTB |= (1 << PB0) | (1 << PB1) |(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7);
			PORTD |= (1 << PD0) | (1 << PD1) |(1 << PD2)|(1 << PD3)|(1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7);
			_delay_ms(500);
			PORTD &= ~(1 << PD7);
			_delay_ms(500);
			PORTD &= ~(1 << PD5);
			_delay_ms(500);	
			PORTC &= ~(1 << PC0);
			_delay_ms(500);
			PORTC &= ~(1 << PC1);
			_delay_ms(500);
	}
}

void full_cube(){
	DDRA = DDRB = DDRC = 0;
	PORTA =	PORTB = PORTC = 0;

	DDRC |= (1 << PC0)|(1 << PC1)|(1 << PC2)|(1 << PC3)|(1 << PC4)|(1 << PC5)|(1 << PC6)|(1 << PC7);
	DDRA |= (1 << PA0)|(1 << PA1)|(1 << PA2)|(1 << PA3)|(1 << PA4)|(1 << PA5)|(1 << PA6)|(1 << PA7);
	DDRB |= (1 << PB0)|(1 << PB1)|(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7);


	DDRD = 0; PORTD = 0;
	DDRD |= (1 << PD7) | (1 << PD6) | (1 << PD5) | (1 << PD4);
	PORTD |= (1 << PD7) | (1 << PD6) | (1 << PD5) | (1 << PD4);

	while(1){
			PORTC |= (1 << PC0) | (1 << PC1) |(1 << PC2)|(1 << PC3)|(1 << PC4)|(1 << PC5)|(1 << PC6)|(1 << PC7);
			PORTA |= (1 << PA0) | (1 << PA1) |(1 << PA2)|(1 << PA3)|(1 << PA4)|(1 << PA5)|(1 << PA6)|(1 << PA7);
			PORTB |= (1 << PB0) | (1 << PB1) |(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7);
			PORTD |= (1 << PD0) | (1 << PD1) |(1 << PD2)|(1 << PD3)|(1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7);
			_delay_ms(500);
	
	}
		

}


void rain(){

	DDRA = DDRB = DDRC = DDRD = 0;
	PORTA =	PORTB = PORTC = PORTD = 0;

	DDRC |= (1 << PC0)|(1 << PC1)|(1 << PC2)|(1 << PC3)|(1 << PC4)|(1 << PC5)|(1 << PC6)|(1 << PC7);
	DDRA |= (1 << PA0)|(1 << PA1)|(1 << PA2)|(1 << PA3)|(1 << PA4)|(1 << PA5)|(1 << PA6)|(1 << PA7);
	DDRB |= (1 << PB0)|(1 << PB1)|(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7);

	DDRD |= (1 << PD7) | (1 << PD6) | (1 << PD5) | (1 << PD4);
	PORTD |= (1 << PD7) | (1 << PD6) | (1 << PD5) | (1 << PD4);


	int i;

	while(1){
		PORTA = (1 << rand()%8) | (1 << rand()%8);
		PORTB = (1 << rand()%8) | (1 << rand()%8);
		
		PORTD |= (1 << PD7);
		_delay_ms(200);

		PORTD |= (1 << PD5);
		_delay_ms(120);

		PORTC |= (1 << PC0);
		_delay_ms(50);

		PORTC |= (1 << PC1);
		_delay_ms(10);
	}


}

void scara(){
	DDRA = DDRB = DDRC = DDRD = 0;
	PORTA =	PORTB = PORTC = PORTD = 0;

	DDRC |= (1 << PC0)|(1 << PC1)|(1 << PC2)|(1 << PC3)|(1 << PC4)|(1 << PC5)|(1 << PC6)|(1 << PC7);
	DDRA |= (1 << PA0)|(1 << PA1)|(1 << PA2)|(1 << PA3)|(1 << PA4)|(1 << PA5)|(1 << PA6)|(1 << PA7);
	DDRB |= (1 << PB0)|(1 << PB1)|(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7);

	DDRD |= (1 << PD7) | (1 << PD6) | (1 << PD5) | (1 << PD4);
	PORTD |= (1 << PD7) | (1 << PD6) | (1 << PD5) | (1 << PD4);

	PORTD |= (1 << PD7);
	PORTD |= (1 << PD5);
	PORTC |= (1 << PC0);
	PORTC |= (1 << PC1);

	int i;

	while(1){
		PORTD |= (1 << PD7);
		PORTA |= (1 << PD5) | (1 << PD4) | (1 << PD1) | (1 << PD0);
		_delay_ms(500);
		PORTA &= ~(1 << PD5); PORTA &= ~(1 << PD4); PORTA &= ~(1 << PD1); PORTA &= ~(1 << PD0);
		//_delay_ms(500);
		PORTD &= ~(1 << PD7);
		PORTA |= (1 << PD7) | (1 << PD6) | (1 << PD3) | (1 << PD2);
		_delay_ms(500);
		PORTA &= ~(1 << PD7); PORTA &= ~(1 << PD6); PORTA &= ~(1 << PD3); PORTA &= ~(1 << PD2);

		PORTC &= ~(1 << PC1);
		PORTB |= (1 << PB7) | (1 << PB0) | (1 << PB6) | (1 << PB2);
		//6 5 4
		//PORTB &= ~(1 << PB7); PORTA &= ~(1 << PB6); PORTA &= ~(1 << PB5); PORTA &= ~(1 << PB4);
		



		//PORTA |= (1 << PD5);
		//_delay_ms(500);

		//PORTA |= (1 << PD4);
		//_delay_ms(500);



		//PORTA |= (1 << PD3);
		//_delay_ms(500);

		//PORTA |= (1 << PD2);
		//_delay_ms(500);

		//PORTA |= (1 << PD1);
		//_delay_ms(500);

		//PORTA |= (1 << PD0);
		//_delay_ms(500);






	}
}



int main(void) {
	//rain();
	scara();
	//succesiv();
	//full_cube();
	
	return 0;
}

	